#define _48BIT

#ifdef _48BIT

// This structure uses bit fields and is only 8 bytes in size.

typedef struct tagLM4_ITEM
{ __int64 unEvent   : 16;
  __int64 nTime     : 48;
} LM4_ITEM, FAR *LPLM4_ITEM;

#else

// This structure is 10 bytes in size.

#pragma pack(2)

typedef struct tagLM4_ITEM
{ __int16 unEvent;
  __int64 nTime;
} LM4_ITEM, FAR *LPLM4_ITEM;

#pragma pack()

#endif

#define LM4_EVENT_ABOVE_SPECTRUM                0x8000  //b#10000000 + 8 additional bits to get a 16 bit variable
#define LM4_EVENT_BELOW_SPECTRUM                0x8100  //b#10000001 + 8 additional bits to get a 16 bit variable
#define LM4_EVENT_NOT_EVALUATED_PUR             0x8200  //b#10000010 + 8 additional bits to get a 16 bit variable
#define LM4_EVENT_NOT_EVALUATED_JC              0x8300  //b#10000011 + 8 additional bits to get a 16 bit variable
#define LM4_EVENT_NOT_EVALUATED                 0x8400  //b#10000100 + 8 additional bits to get a 16 bit variable
#define LM4_EVENT_OVERFLOW_BEGIN                0x8500  //b#10000101 + 8 additional bits to get a 16 bit variable
#define LM4_EVENT_OVERFLOW_END                  0x8600  //b#10000110 + 8 additional bits to get a 16 bit variable
#define LM4_EVENT_DISCARDED_CYCLE               0x8700  //b#10000111 + 8 additional bits to get a 16 bit variable
#define LM4_EVENT_PRESET_RT_REACHED             0x8800  //b#10001000 + 8 additional bits to get a 16 bit variable



#define RAC_COMPLETE        0 // The complete list was processed.
#define RAC_MEM_USED_UP     1 // The process was stopped because the memory was used up before the file end. The items according to lpulItems are valid.
#define RAC_INCONSISTENT    2 // The process was stopped because the file is inconsistent. The items according to lpulItems are valid.
#define RAC_NO_LM4          3 // The file does not contain list mode 4 data.

// szFileName:          the name of the *.mca file
// lpLm4Items:          pointer to an array of items
// lpulItems:           in: number of items according to the size of the passed array, out: number of evaluated items
// lpunTimeUnitLength:  out: time unit length in nanoseconds read from the file
// bAllEvents:          If TRUE, all events are considered. If FALSE, only the events that causes counts within the spectrum are considered.

unsigned short  ReadAndConvert(LPSTR szFileName,LPLM4_ITEM lpLm4Items,unsigned long* lpulItems,unsigned short* lpunTimeUnitLength,BOOL bAllEvents);


