// test_lm4Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "test_lm4.h"
#include "test_lm4Dlg.h"
#include "funcs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTest_lm4Dlg dialog

CTest_lm4Dlg::CTest_lm4Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTest_lm4Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTest_lm4Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTest_lm4Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTest_lm4Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTest_lm4Dlg, CDialog)
	//{{AFX_MSG_MAP(CTest_lm4Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTest_lm4Dlg message handlers

BOOL CTest_lm4Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

  ((CButton*)GetDlgItem(IDC_CHECK_TEXT_FILE))->SetCheck(1);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTest_lm4Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTest_lm4Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTest_lm4Dlg::OnOK() 
{ CFileDialog dlgFile(TRUE,"mca",NULL,OFN_HIDEREADONLY,_T("MCA file (*.mca)|*.mca||"),this);

  if(dlgFile.DoModal()==IDOK)
  { CString strFileName=dlgFile.GetPathName();

    unsigned long ulItems=100000;
    unsigned short unTimeUnitLength;

    TRACE1("%d\n",sizeof(LM4_ITEM));
  
    LPLM4_ITEM lpLm4Items=(LPLM4_ITEM)LocalAlloc(LPTR,ulItems*sizeof(LM4_ITEM));

    if(lpLm4Items)
    { char szBuffer[100];
    
      ReadAndConvert(strFileName.GetBuffer(MAX_PATH),lpLm4Items,&ulItems,&unTimeUnitLength,TRUE);

      sprintf(szBuffer,"%lu items evaluated.",ulItems);

      GetDlgItem(IDC_STATIC_INFO)->SetWindowText(szBuffer);

      if(ulItems && ((CButton*)GetDlgItem(IDC_CHECK_TEXT_FILE))->GetCheck())
      { CFileDialog dlgFileTxt(FALSE,"txt",NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,_T("Text file (*.txt)|*.txt||"),this);

        if(dlgFileTxt.DoModal()==IDOK)
        { CStdioFile outfile;
          char szBuffer[50];

          strFileName=dlgFileTxt.GetPathName();

          if(outfile.Open(strFileName.GetBuffer(MAX_PATH),CFile::modeCreate | CFile::modeWrite))
          { double d,dt=(double)unTimeUnitLength;

            for(unsigned long u=0;u<ulItems;u++)
            { d=dt*(double)lpLm4Items[u].nTime/1000000000.0;
        
              sprintf(szBuffer,"%12.7f sec. | ",d);

              outfile.WriteString(szBuffer);
      
              switch((unsigned short)lpLm4Items[u].unEvent)
              { case LM4_EVENT_ABOVE_SPECTRUM:
          
                  outfile.WriteString("Above spectrum\n");
                  break;
          
                case LM4_EVENT_BELOW_SPECTRUM:
          
                  outfile.WriteString("Below spectrum\n");
                  break;
          
                case LM4_EVENT_NOT_EVALUATED_PUR:
          
                  outfile.WriteString("Not evaluated (PUR)\n");
                  break;
          
                case LM4_EVENT_NOT_EVALUATED_JC:
          
                  outfile.WriteString("Not evaluated (JC)\n");
                  break;
          
                case LM4_EVENT_NOT_EVALUATED:
          
                  outfile.WriteString("Not evaluated (?)\n");
                  break;
          
                case LM4_EVENT_OVERFLOW_BEGIN:
          
                  outfile.WriteString("Overflow begin\n");
                  break;
          
                case LM4_EVENT_OVERFLOW_END:
          
                  outfile.WriteString("Overflow end\n");
                  break;
          
                case LM4_EVENT_DISCARDED_CYCLE:
          
                  outfile.WriteString("Discarded cycle\n");
                  break;
          
                case LM4_EVENT_PRESET_RT_REACHED:
          
                  outfile.WriteString("Preset RT reached\n");
                  break;
          
                default:
      
                  sprintf(szBuffer,"Channel %5u\n",(unsigned short)(lpLm4Items[u].unEvent));

                  outfile.WriteString(szBuffer);
              }
            }

            outfile.Close();
          }
        }
      }

      LocalFree(lpLm4Items);
    }
  }
}
